#define port_counter 80
#define port_kb_low  60
#define port_kb_high 61

#include "lcd.h"


#define CHAR_SPACE  0x20
#define CHAR_B      0x42
#define CHAR_K      0x4B

volatile unsigned char keypressed = 0; 


void isr(void) interrupt
{
   keypressed = 1;
   __asm
     DISABLE INTERRUPT
   __endasm;
}

unsigned char readkey(void)
{
  volatile unsigned char key = 0;

      __asm
readkb:
       INPUT s1, port_kb_low
xch1:
       SRA  s1
       JUMP NC, xch4
       LOAD _key, 31
       JUMP xchno

xch4:
       SRA  s1
       JUMP NC, xch7
       LOAD _key, 34
       JUMP xchno

xch7:
       SRA  s1
       JUMP NC, xchs
       LOAD _key, 37
       JUMP xchno

xchs:
       SRA  s1
       JUMP NC, xch2
       LOAD _key, 2A
       JUMP xchno

xch2:
       SRA  s1
       JUMP NC, xch5
       LOAD _key, 32
       JUMP xchno

xch5:
       SRA  s1
       JUMP NC, xch8
       LOAD _key, 35
       JUMP xchno

xch8:
       SRA  s1
       JUMP NC, xch0
       LOAD _key, 38
       JUMP xchno

xch0:
       SRA  s1
       JUMP NC, xch3
       LOAD _key, 30
       JUMP xchno

xch3:
       INPUT s1, port_kb_high
       SRA  s1
       JUMP NC, xch6
       LOAD _key, 33
       JUMP xchno

xch6:
       SRA  s1
       JUMP NC, xch9
       LOAD _key, 36
       JUMP xchno

xch9:
       SRA  s1
       JUMP NC, xchm
       LOAD _key, 39
       JUMP xchno

xchm:
       SRA  s1
       JUMP NC, xcha
       LOAD _key, 23
       JUMP xchno

xcha:
       SRA  s1
       JUMP NC, xchb
       LOAD _key, 41
       JUMP xchno

xchb:
       SRA  s1
       JUMP NC, xchc
       LOAD _key, 42
       JUMP xchno

xchc:
       SRA  s1
       JUMP NC, xchd
       LOAD _key, 43
       JUMP xchno

xchd:
       SRA  s1
       JUMP NC, xchno
       LOAD _key, 44
       
xchno:

  __endasm;
  
  return key;
} 

    

void main(void)
{
  volatile unsigned char ch = 0;
  LCD_init();
  LCD_wr(CHAR_K);
  LCD_wr(CHAR_B);
  LCD_wr(CHAR_SPACE);

for(;;)
{  
  __asm
       ENABLE INTERRUPT
  __endasm;
  
  // otestovat flag
  while(!keypressed)
  { 
    delay(1);
  }
  
  __asm
       DISABLE INTERRUPT
  __endasm;
  
  // zrusit flag
  keypressed = 0; 

  ch = readkey(); //zjistit stisknutou klavesu

  LCD_wr(ch);
  LCD_wr('X');
  delay(100);
}
//  delay(10);
                
}