@ECHO ON
@ECHO PicoBlaze C Compiler (c) 2008-2010, Brno University of Technology, krivka@fit.vutbr.cz
@ECHO Usage: "pbcc.bat source.c [kcpsm3|pblazeide] [pause]"

@REM Compilation System - Batch Configuration
@REM Paths from the executing directory to directories of required tools
@SET SDCC_PATH="..\sdcc\bin_vc"
@SET PBCC_PATH="..\kernel"
@SET ASM_PATH="..\KCPSM3\Assembler"
@SET SIMUL_PATH="..\pblazeide"

@REM Compilation System - Initial values
@SET STARTING_PATH=%CD%
@SET FILENAMEEXT=%1
@SET FILENAME=%FILENAMEEXT:~0,-2%
@SET FILEEXT=%FILENAMEEXT:~-2%
@SET PARPAUSE=0 
@SET PARDIALECT=
@REM Make the paths absolute, not relative with the STARTING_PATH
@cd %STARTING_PATH%
@cd %SDCC_PATH%
@SET SDCC_PATH=%CD%
@cd %STARTING_PATH%
@cd %PBCC_PATH%
@SET PBCC_PATH=%CD%
@cd %STARTING_PATH%
@cd %ASM_PATH%
@SET ASM_PATH=%CD%
@cd %STARTING_PATH%
@cd %SIMUL_PATH%
@SET SIMUL_PATH=%CD%
@cd %STARTING_PATH%

:checkparams
@IF NOT EXIST %1 GOTO badfilename
@IF "%FILEEXT%" NEQ ".c" GOTO badfileext
@IF "%2"=="kcpsm3" SET PARDIALECT=kcpsm3
@IF "%2"=="pblazeide" SET PARDIALECT=pblazeide
@IF "%2"=="pause" SET PARPAUSE=1
@IF "%3"=="pause" SET PARPAUSE=1
@IF "%3"=="kcpsm3" IF "%PARDIALECT%"=="" (SET PARDIALECT=kcpsm3) ELSE (GOTO badparam)
@IF "%3"=="pblazeide" IF "%PARDIALECT%"=="" (SET PARDIALECT=pblazeide) ELSE (GOTO badparam)
@IF "%PARDIALECT%"=="" SET PARDIALECT=kcpsm3

@ECHO Processing C source (%1) by PBCC Front-End (SDCC)...
@ECHO Used parameters: dialect=%PARDIALECT% and pause=%PARPAUSE%

:start
@ECHO Preparing %1 for processing...
@cd %STARTING_PATH% 
@copy %1 %SDCC_PATH%\%1
@cd %SDCC_PATH%
@IF EXIST %1.json @DEL %1.json
@call pbccf.bat %1
@IF NOT EXIST %1.json GOTO badsdcc 
@IF "%PARPAUSE%"=="1"  @pause

@ECHO Processing intermediate code by PBCC Back-End (Pharo)...
@ECHO Preparing %1.json -> %FILENAME%.json for processing... 
@move /Y %1.json %PBCC_PATH%\%FILENAME%.json
@cd %PBCC_PATH%
@IF EXIST %FILENAME%.json.asm @DEL %FILENAME%.json.asm
@IF EXIST %FILENAME%.json.wrn @DEL %FILENAME%.json.wrn
@IF EXIST %FILENAME%.json.log @DEL %FILENAME%.json.log
@IF EXIST %FILENAME%.json.err @DEL %FILENAME%.json.err

@CALL pbccb.bat %FILENAME%.json %PARDIALECT%

@IF EXIST %FILENAME%.json.log  @type %FILENAME%.json.log
@IF EXIST %FILENAME%.json.wrn  @type %FILENAME%.json.wrn
@IF EXIST %FILENAME%.json.err  @type %FILENAME%.json.err
@IF EXIST %FILENAME%.json.err  GOTO badpbcc
@IF NOT EXIST %FILENAME%.json.asm GOTO badpbcc 

@IF "%PARDIALECT%"=="kcpsm3" GOTO kcpsm3
@IF "%PARDIALECT%"=="pblazeide" GOTO pblazeide
@GOTO badparams

:kcpsm3
@ECHO Preparing %FILENAME.json.asm -> %FILENAME%.psm for processing...
@move /Y %FILENAME%.json.asm %ASM_PATH%\%FILENAME%.psm
@IF "%PARPAUSE%"=="1"  @pause

@ECHO Translating assembler code to HEX and VHDL (KCPSM3)...
@cd %ASM_PATH%
@IF EXIST %FILENAME%.FMT @DEL %FILENAME%.FMT
@IF EXIST %FILENAME%.LOG @DEL %FILENAME%.LOG
@IF EXIST %FILENAME%.COE @DEL %FILENAME%.COE
@IF EXIST %FILENAME%.VHD @DEL %FILENAME%.VHD
@IF EXIST %FILENAME%.V @DEL %FILENAME%.V
@IF EXIST %FILENAME%.M @DEL %FILENAME%.M
@IF EXIST %FILENAME%.DEC @DEL %FILENAME%.DEC
@IF EXIST %FILENAME%.MEM @DEL %FILENAME%.MEM
@IF EXIST PASS1.DAT @DEL PASS1.DAT
@IF EXIST PASS2.DAT @DEL PASS2.DAT
@IF EXIST CONSTANT.TXT @DEL CONSTANT.TXT
@IF EXIST PASS3.DAT @DEL PASS3.DAT
@IF EXIST LABELS.TXT @DEL LABELS.TXT
@IF EXIST PASS4.DAT @DEL PASS4.DAT
@IF EXIST PASS5.DAT @DEL PASS5.DAT
                                                                                                  
@KCPSM3.EXE %FILENAME%.psm

@ECHO Preparing the resulting file %FILENAME%.hex...
@move /Y %FILENAME%.hex %STARTING_PATH%\%FILENAME%.hex
@cd %STARTING_PATH%
@ECHO -------------------------------
@IF NOT EXIST %FILENAME%.hex GOTO badasm 
@ECHO The compilation process of %1 COMPLETED!
@GOTO end

:pblazeide
@ECHO Preparing %FILENAME.json.asm -> %FILENAME%.psm for simulation...
@copy /Y %FILENAME%.json.asm %STARTING_PATH%\%FILENAME%.psm
@move /Y %FILENAME%.json.asm %SIMUL_PATH%\%FILENAME%.psm
@ECHO -------------------------------
@ECHO The compilation process of %1 COMPLETED!
@GOTO end


@REM Error Messages
:badparams
@ECHO Bad parameters (%*)! See usage instructions.
@GOTO end
:badfilename
@ECHO Bad filename %1!
@GOTO end
:badfileext
@ECHO Bad filename extension (%FILEEXT%). Only ".c" supported!
@GOTO end
:badsdcc
@ECHO The compilation TERMINATED: Error in C source (%1). See SDCC error messages.
@GOTO end 
:badpbcc
@ECHO The compilation TERMINATED: Error in intermediate code (%FILENAME%.json). See error log (%FILENAME%.json.err).
@GOTO end
:badasm
@ECHO The compilation TERMINATED: Error in PSM -> HEX+VHDL proces (%FILENAME%.psm). See errors from KCPSM3.
@GOTO end

:end
@cd %STARTING_PATH%